﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using EGIS.ShapeFileLib;
using System.IO;

/*
 * 
 * DISCLAIMER OF WARRANTY: THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 * WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE OR NON-INFRINGING.
 * THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOFTWARE IS WITH YOU. SHOULD ANY COVERED CODE PROVE DEFECTIVE IN ANY RESPECT,
 * YOU (NOT CORPORATE EASY GIS .NET) ASSUME THE COST OF ANY NECESSARY SERVICING, REPAIR OR CORRECTION.  
 * 
 * LIABILITY: IN NO EVENT SHALL CORPORATE EASY GIS .NET BE LIABLE FOR ANY DAMAGES WHATSOEVER (INCLUDING, WITHOUT LIMITATION, 
 * DAMAGES FOR LOSS OF BUSINESS PROFITS, BUSINESS INTERRUPTION, LOSS OF INFORMATION OR ANY OTHER PECUNIARY LOSS)
 * ARISING OUT OF THE USE OF INABILITY TO USE THIS SOFTWARE, EVEN IF CORPORATE EASY GIS .NET HAS BEEN ADVISED OF THE POSSIBILITY
 * OF SUCH DAMAGES.
 * 
 * Copyright: Easy GIS .NET 2013
 *
 */

namespace Example10
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            OpenShapeFile("basemap_route_road\\basemap_route_road.shp");
            ofdXyzFile.InitialDirectory = Application.StartupPath;
            //GenerateXYFile();
        }


        //private void GenerateXYFile()
        //{
        //    generate a sample XYZ file
        //    ShapeFile sf = sfMap1[0];
        //    PointD[] pts = sf.GetShapeDataD(4220)[0];
        //    double[] measures = sf.GetShapeMDataD(4220)[0];
        //    Console.Out.WriteLine(measures.Length);
        //    double chainage = 0.0001, endChainage = measures[measures.Length-1];
        //    int currentIndex = 0;
        //    Console.Out.WriteLine("measures.Length: " + measures.Length);
        //    Console.Out.WriteLine("end chainage: " + endChainage);
        //    double increment = 15.0 / 1609;
        //    int generatedPointCount = 0;
        //    Random r = new Random();
        //    using(StreamWriter sw = new StreamWriter(@"c:\temp\test.xyz"))
        //    {
        //        while (chainage < endChainage && currentIndex < (measures.Length-1))
        //        {
        //            double ratio = (chainage - measures[currentIndex]) / (measures[currentIndex + 1] - measures[currentIndex]);
        //            //Console.Out.WriteLine("ratio:" + ratio);
        //            PointD nextPoint = new PointD(pts[currentIndex].X + ratio * (pts[currentIndex + 1].X - pts[currentIndex].X),
        //                                          pts[currentIndex].Y + ratio * (pts[currentIndex + 1].Y - pts[currentIndex].Y) );
        //            nextPoint.X += r.NextDouble() * 4 - 2;
        //            nextPoint.Y += r.NextDouble() * 1 - 0.5;
        //            sw.WriteLine("{0:0.00000},{1:0.00000}", nextPoint.X, nextPoint.Y);
        //            ++generatedPointCount;
        //            chainage += increment;
        //            while (currentIndex < (measures.Length-1) && measures[currentIndex + 1] < chainage) currentIndex++;
        //        }
        //    }
        //    Console.Out.WriteLine("chainage:" + chainage);
        //    Console.Out.WriteLine("end chainage: " + endChainage);            
        //    Console.Out.WriteLine("generatedPointCount: " + generatedPointCount);
        //    Console.Out.WriteLine("expected count: " + endChainage / increment);

        //}

        #region "Functions to get linear reference from clicked point"
        

        private void sfMap1_MouseDown(object sender, MouseEventArgs e)
        {
            GetLinearReference(e.X, e.Y);
        }

        private PointD clickedPoint;
        private PolylineDistanceInfo polylineDistanceInfo;
        private int lastFoundRecord = -1;

        private void GetLinearReference(int mouseX, int mouseY)
        {
            PointD coords = sfMap1.PixelCoordToGisPoint(mouseX, mouseY);
            double dist;
            if (rbMapUnits.Checked)
            {
                dist = (double)nudMaxDistance.Value;
            }
            else
            {
                //convert the pixel distance into map units
                int pixelDistance =(int) Math.Round((double)nudMaxDistance.Value);
                PointD coords2 = sfMap1.PixelCoordToGisPoint(mouseX + pixelDistance, mouseY + pixelDistance);
                dist = Math.Sqrt((coords.X - coords2.X) * (coords.X - coords2.X) + (coords.Y - coords2.Y) * (coords.Y - coords2.Y));                
            }
            
            ShapeFile roadShapeFile = sfMap1[0];
            //check if the loaded shapefile is a polyline or polylineM shapefile
            if (!(roadShapeFile.ShapeType == ShapeType.PolyLine || roadShapeFile.ShapeType == ShapeType.PolyLineM || roadShapeFile.ShapeType == ShapeType.PolyLineZ)) return;
            int index;
            System.Collections.ObjectModel.ReadOnlyCollection<int> selectedRecords = roadShapeFile.SelectedRecordIndices;
            if (selectedRecords.Count > 0)
            {
                //if any of the records are selected then restrict the search to the selected records
                index = roadShapeFile.GetClosestShape(coords, dist, selectedRecords, out this.polylineDistanceInfo);
            }
            else
            {
                index = roadShapeFile.GetClosestShape(coords, dist, out this.polylineDistanceInfo);
            }
            lastFoundRecord = index;                            
            if (index >= 0)
            {
                Console.Out.WriteLine("LineSegmentSide:" + polylineDistanceInfo.LineSegmentSide);            
                clickedPoint = coords;                
                if ((roadShapeFile.ShapeType == ShapeType.PolyLineM || roadShapeFile.ShapeType == ShapeType.PolyLineZ) && cbReferenceField.SelectedIndex >=0)
                {

                    double[] measures = roadShapeFile.GetShapeMDataD(index)[0];
                    double distance = measures[polylineDistanceInfo.PointIndex] + polylineDistanceInfo.TVal * (measures[polylineDistanceInfo.PointIndex + 1] - measures[polylineDistanceInfo.PointIndex]);                        
                    txtLinearReferenceDescription.Text = string.Format("{0:0.000} m from start of {1}",
                        new object[] {
                            distance,
                            roadShapeFile.GetAttributeFieldValues(index)[cbReferenceField.SelectedIndex]                            
                        });
                   
                     rtbOutput.AppendText(string.Format("Clicked point {0:0.000} m from start of polyline. Horizontal offset: {2:0.0} m {3}\n",
                        new object[] {
                            distance,
                            roadShapeFile.GetAttributeFieldValues(index)[cbReferenceField.SelectedIndex],
                            polylineDistanceInfo.Distance,
                            GetLineSegmentSideDescription(polylineDistanceInfo.LineSegmentSide)
                        }));
                     rtbOutput.ScrollToCaret();
                }
                sfMap1.Refresh();
            }            
        }

        private string GetLineSegmentSideDescription(LineSegmentSide lineSegmentSide)
        {
            switch (lineSegmentSide)
            {
                case LineSegmentSide.LeftOfSegment:
                    return "left of road center";
                case LineSegmentSide.RightOfSegment:
                    return "right of road center";
                case LineSegmentSide.StartOfSegment:
                    return "from start of road";
                case LineSegmentSide.EndOfSegment:
                    return "after end of road";
                default:
                    return "";
            }
        }

        private void sfMap1_Paint(object sender, PaintEventArgs e)
        {
            if(lastFoundRecord >=0)
            {
                Graphics g = e.Graphics;
            
                g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
                Point pt = sfMap1.GisPointToPixelCoord(polylineDistanceInfo.PolylinePoint);
                g.FillEllipse(Brushes.Red, pt.X - 5, pt.Y - 5, 10, 10);

                Point mousePoint = sfMap1.GisPointToPixelCoord(clickedPoint);
                if ((mousePoint.X - pt.X) * (mousePoint.X - pt.X) + (mousePoint.Y - pt.Y) * (mousePoint.Y - pt.Y) > 50 * 50)
                {
                    g.FillEllipse(Brushes.Red, mousePoint.X - 2, mousePoint.Y - 2, 4, 4);
                    g.DrawLine(Pens.Red, mousePoint, pt);
                }
            }
        }

        #endregion

        #region "Open Shapefile"

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (ofdShapefile.ShowDialog(this) == DialogResult.OK)
            {
                OpenShapeFile(ofdShapefile.FileName);
            }
        }


        private void OpenShapeFile(string path)
        {           
            sfMap1.ClearShapeFiles();
            ShapeFile sf = sfMap1.AddShapeFile(path, System.IO.Path.GetFileNameWithoutExtension(path), "NAME");
            string[] fieldNames = sf.GetAttributeFieldNames();

            cbReferenceField.Items.Clear();
            cbReferenceField.Items.AddRange(fieldNames);
            if (cbReferenceField.Items.Count > 0) cbReferenceField.SelectedIndex = 0;

            sf.RenderSettings.FieldName = fieldNames[0];
            sf.RenderSettings.Font = this.Font;
            //mark the shapefile as selectable for debug purposes
            sf.RenderSettings.IsSelectable = true;           
        }

        #endregion

        #region "Functions to read coordinates from file and perform linear referencing"


        private void openXYZRecordsToolStripMenuItem_Click(object sender, EventArgs e)
        {            
            if (ofdXyzFile.ShowDialog(this) == DialogResult.OK)
            {
                ofdXyzFile.InitialDirectory = "";
                XYZRecordList xyzRecords;                
                xyzRecords = OpenXyzFile(ofdXyzFile.FileName);                                    
                rtbOutput.Clear();
                rtbOutput.AppendText("Loaded " + xyzRecords.Count + " records\n");
                rtbOutput.Refresh();
                DateTime dts = DateTime.Now;
                PerformLinearReferencing(xyzRecords);
                rtbOutput.AppendText(string.Format("\nTotal time to process {0} records {1:0.00}s\n", xyzRecords.Count, DateTime.Now.Subtract(dts).TotalSeconds));                
            }
           
        }

        private void PerformLinearReferencing(XYZRecordList xyzRecords)
        {
            int percent = -1;
            double maxDistance = (double)nudMaxDistance.Value;
            StringBuilder sb = new StringBuilder();
            for (int n = 0; n < xyzRecords.Count; ++n)
            {
                string result = PerformLinearReferencing(new PointD(xyzRecords[n].X, xyzRecords[n].Y), maxDistance);
                sb.Append(n).Append(':');
                sb.Append(result);
                sb.Append('\n');
                int currentPercent = (int)Math.Round(100.0 * (n + 1.0) / xyzRecords.Count);
                if (currentPercent != percent)
                {
                    percent = currentPercent;
                    tslPercent.Text = string.Format("[{0:0}%]", percent);
                    tspbPercent.Value = percent;
                    statusStrip1.Refresh();
                }                
            }
            rtbOutput.AppendText(sb.ToString());
        }

        private string PerformLinearReferencing(PointD coords, double maxDistance)
        {
            if(sfMap1.ShapeFileCount == 0) return "";
            ShapeFile roadShapeFile = sfMap1[0];
            PolylineDistanceInfo polylineDistanceInfo;
            int index;
            index = roadShapeFile.GetClosestShape(coords, maxDistance, out polylineDistanceInfo);
            if (index >= 0)
            {                    
                if (roadShapeFile.ShapeType == ShapeType.PolyLineM && cbReferenceField.SelectedIndex >= 0)
                {
                    double[] measures = roadShapeFile.GetShapeMDataD(index)[0];
                    double distance = measures[polylineDistanceInfo.PointIndex] + polylineDistanceInfo.TVal * (measures[polylineDistanceInfo.PointIndex + 1] - measures[polylineDistanceInfo.PointIndex]);
                    double distanceFromEnd = measures[measures.Length-1] - distance;
                    string recordDescription = roadShapeFile.GetAttributeFieldValues(index)[cbReferenceField.SelectedIndex].Trim();
                    if(string.IsNullOrEmpty(recordDescription)) recordDescription = "<unknown>";
                    return string.Format("{0:0.000} km from start of {1}, {2:0.000} km from end [{3:0.00}m from record no {4}]", new object[] { distance, recordDescription, distanceFromEnd, polylineDistanceInfo.Distance, index });
                }
            }
            return "Could not obtain linear reference";                     
        }

        /// <summary>
        /// Opens an XYZ file and reads the records
        /// </summary>
        /// <param name="path"></param>
        /// <returns>A collection of XYZRecords</returns>
        private XYZRecordList OpenXyzFile(string path)
        {           
            XYZRecordList xyzRecords = new XYZRecordList();
            using (StreamReader reader = new StreamReader(path))
            {
                xyzRecords.ReadRecords(reader);                
            }
            return xyzRecords;          
        }

        #endregion


        private void cbReferenceField_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (sfMap1.ShapeFileCount > 0 && cbReferenceField.SelectedIndex >=0)
            {
                sfMap1[0].RenderSettings.FieldName = cbReferenceField.SelectedItem as string;
            }
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

               

    }
}
